/**********************************************************************
*                                                                     *
*  main.cpp: main driver for Simple Calculator parser                 *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "public.h"     /* define global information */
#include "dcalc.h"
/*#include "abxlex.hpp"*/
#include "abxyacc.hpp"

FILE    *yyin;          /* pointer to input stream */
char yyerrsrc[TEXTLEN]; /* input filename */
int c;

extern int yylineno;    /* current line number defined in lex.l */
extern int yyerrcnt;    /* count of errors, defined in err_skel.c */
/*extern int yyparse(void);*/   /* defined in err_skel.c */

void main(int argc, char *argv[])
{

  if (argc<2)
  {
    fprintf(stderr, "\nPCYACC (R) is a software product of ABRAXAS SOFTWARE INC.\n");
    fprintf(stderr, "Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.\n\n");
    fprintf(stderr,"Usage : dcalc <program>\n");
    exit(1);
  }

  yyin=fopen(argv[1],"rw");
  if (yyin==0)
  {
    fprintf(stderr,"Can't open source program file %s\n", argv[1]);
    exit(1);
  }

  strcpy(yyerrsrc,argv[1]);

  yylineno=1;

ABXLex mylex(yyin);
ABXYacc myyacc(&mylex);
myyacc.yyParse();

  fclose(yyin);

  if (yyerrcnt!=0)
  {
    fprintf(stderr,"%d error%s found by the parser\n",yyerrcnt,(yyerrcnt==1)?"":"s");
  }
  else
  {
    fprintf(stdout,"No syntax error was found by the parser\n");
  }
  exit(0);
}
