/*
=====================================================================
  MAIN.C: main routine for JAVA parser
  Verion 1.0
  by Daming Liu

  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.  
  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.
  
=====================================================================
*/


#include <stdio.h>      /* FILE, NULL, stderr, fopen(), fclose(), fprintf() */
#include <stdlib.h>     /* EXIT_FAILURE, EXIT_SUCCESS, exit() */
#include <string.h>     /* strcpy() */

extern int yylineno;	      /* line # of current line, defined in lex.l */
extern int error_count;		  /* count of errors, defined in err_skel.c */
extern char yyerrsrc[64];	  /* input file name, defined in lex.l */
extern int yyparse(void);     /* defined in err_skel.c */

FILE *yyin;                   /* pointer to theinput file */

main(int argc, char *argv[])
{
    if (argc < 2)    
    {	 
        fprintf(stderr, "\nUsage:\n\t java <program> \n\n");
        exit(EXIT_FAILURE);            /* EXIT_FAILURE = 1 */
    }
  
    yyin = fopen(argv[1], "r");
    if (yyin == NULL) 
    {
	fprintf(stderr, "Can't open source program file %s\n", argv[1]);
        exit(EXIT_FAILURE);            /* EXIT_FAILURE = 1 */
    }
    
    strcpy(yyerrsrc, argv[1]);

    yylineno = 1;

    (void) yyparse();
    fclose(yyin);

    if (error_count != 0)    
    {
    	 fprintf(stderr, 
	         "\n\n<====    %d error%s found by the parser    ====>\n\n\n",
	         error_count,  (error_count == 1) ? "" : "s");

         exit(EXIT_FAILURE);
    }
    else    
    {	 
         fprintf(stdout, 
      "\n\n\n<====    No syntax error was found by the parser    ====>\n\n\n");
    }
    
    exit(EXIT_SUCCESS);                /* EXIT_SUCCESS = 0 */}
